using Insight.Infrastructure;
using Insight.Infrastructure.Entities;
using Insight.Web.Components.Containers;
using Insight.Web.Constants;
using Microsoft.AspNetCore.Components;
using MongoDB.Bson;
using MongoDB.Driver;
using MudBlazor;
using System.Text.RegularExpressions;
using SortDirection = MudBlazor.SortDirection;

namespace Insight.Web.Pages.Management.Hosts.Systems.Volumes;

[Route(Navigation.Management.Hosts.Systems.Volumes.Index)]
public partial class Index
{
    [Parameter] public string? HostId { get; set; }

    [Inject] private IMongoDatabase Database { get; init; } = default!;
    [Inject] private ISnackbar Snackbar { get; init; } = default!;
    [Inject] private NavigationManager NavigationManager { get; init; } = default!;

    private TableContainer<HostVolumeEntity>? Container { get; set; }
    private string Title { get; set; } = Global.Name;
    private List<BreadcrumbItem> Breadcrumbs { get; } = new();
    private string? Search { get; set; }

    protected override async Task OnInitializedAsync()
    {
        if (string.IsNullOrWhiteSpace(HostId) || ObjectId.TryParse(HostId, out var hostId) is false)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        var host = await Database.Host()
            .Find(Builders<HostEntity>
            .Filter
            .Eq(p => p.Id, HostId))
            .FirstOrDefaultAsync(default);

        if (host is null)
        {
            Notification.Error(Snackbar, "Not Found");
            NavigationManager.NavigateTo(Navigation.Management.Hosts.Index);
            return;
        }

        Title = $"Hosts » {host.Name} » Volumes｜Insight";
        Breadcrumbs.Add(new BreadcrumbItem("Home", href: Navigation.Home));
        Breadcrumbs.Add(new BreadcrumbItem("Hosts", href: Navigation.Management.Hosts.Index));
        Breadcrumbs.Add(new BreadcrumbItem(host.Name, href: Navigation.Management.Hosts.DetailsHref(HostId)));
        Breadcrumbs.Add(new BreadcrumbItem("Volumes", href: "#", true));
    }

    private async Task<TableData<HostVolumeEntity>> LoadDataAsync(TableState state)
    {
        try
        {
            var filter = Builders<HostVolumeEntity>.Filter.Eq(p => p.Host, HostId);

            if (string.IsNullOrWhiteSpace(Search) is false)
            {
                var regex = new BsonRegularExpression(new Regex(Search, RegexOptions.IgnoreCase));
                filter &= Builders<HostVolumeEntity>.Filter.Regex(x => x.Name, regex) |
                    Builders<HostVolumeEntity>.Filter.Regex(x => x.Type, regex) |
                    Builders<HostVolumeEntity>.Filter.Regex(x => x.FileSystem, regex) |
                    Builders<HostVolumeEntity>.Filter.Regex(x => x.Size, regex) |
                    Builders<HostVolumeEntity>.Filter.Regex(x => x.FreeSpace, regex) |
                    Builders<HostVolumeEntity>.Filter.Regex(x => x.Name, regex);
            }

            var query = Database.HostVolume()
                .Find(filter)
                .Sort(state.SortDirection switch
                {
                    SortDirection.Ascending => state.SortLabel switch
                    {
                        "Name" => Builders<HostVolumeEntity>.Sort.Ascending(p => p.Name),
                        "Type" => Builders<HostVolumeEntity>.Sort.Ascending(p => p.Type),
                        "FileSystem" => Builders<HostVolumeEntity>.Sort.Ascending(p => p.FileSystem),
                        "Size" => Builders<HostVolumeEntity>.Sort.Ascending(p => p.Size),
                        "FreeSpace" => Builders<HostVolumeEntity>.Sort.Ascending(p => p.FreeSpace),
                        "Drive" => Builders<HostVolumeEntity>.Sort.Ascending(p => p.Name),
                        _ => null
                    },
                    SortDirection.Descending => state.SortLabel switch
                    {
                        "Name" => Builders<HostVolumeEntity>.Sort.Descending(p => p.Name),
                        "Type" => Builders<HostVolumeEntity>.Sort.Descending(p => p.Type),
                        "FileSystem" => Builders<HostVolumeEntity>.Sort.Descending(p => p.FileSystem),
                        "Size" => Builders<HostVolumeEntity>.Sort.Descending(p => p.Size),
                        "FreeSpace" => Builders<HostVolumeEntity>.Sort.Descending(p => p.FreeSpace),
                        "Drive" => Builders<HostVolumeEntity>.Sort.Descending(p => p.Name),
                        _ => null
                    },
                    _ => Builders<HostVolumeEntity>.Sort.Ascending(p => p.Label).Ascending(p => p.Name)
                });

            return new TableData<HostVolumeEntity>()
            {
                TotalItems = (int)await query.CountDocumentsAsync(default),
                Items = await query.Skip(state.Page * state.PageSize).Limit(state.PageSize).ToListAsync(default)
            };
        }
        catch (Exception)
        {
            Notification.Error(Snackbar);
            return new TableData<HostVolumeEntity>();
        }
    }
}